#!/usr/bin/perl 

use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"
if (param())
{
    print_to_file();                             #print data to log file "inputs.log" to have an input reference
    print_data();                                #prints to a file the data that user provides 
    Lagrange();                                  #call subroutine Lagrange to solve the problem and prind the data for plotting
    &Gnuplot();
    system("convert Lagrange.ps -size 100x200 -rotate 90 Lagrange.jpg");#convert from ps to jpg
    system("chmod a+rw Lagrange.jpg");
    system(" mv Lagrange.jpg /home/simos/public_html/images/ArithmAnal/Lagrange/");
    return_form();                               #call subroutine return_form
    webtail();
    print $object->end_html();                   #end the html
}


###### The following are the required subroutines ######

sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Lagrange approximation',                                   #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Lagrange Polynomial Approximation'),                              #level 1 header
    $object->startform('POST');
}

sub print_form
{
    print $object->start_form('POST'),
    $object->body('This is a demostration of the Lagrange polynomial approximation of functions. The user provides a list of 4 numbers for x and f(x) and the program calculates the 3rd order Lagrange polynomial that approximates the function that passes through those points. The final output is the plot of this approximation togeather with the provided points. Fields marked with a star are optional. After pressing the "Approximate f(x)" button, scroll down to see the results. All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). For questions or to report problems please contact: simos@astro.auth.gr '),
    $object->p,
    $object->body('*Please give your name: '),
    $object->textfield('name','guest','20','20'),                          #create a text field
    $object->p,
    $object->body('Please fill the following table with the values of x and f(x):'),
    $object->p,
    $object->table({-border=>udef},
		   $object->Tr({-align=>CENTER,-valign=>TOP},
			       [
				$object->th('x').$object->td($object->textfield('x0','','10','10')).$object->td($object->textfield('x1','','10','10')).$object->td($object->textfield('x2','','10','10')).$object->td($object->textfield('x3','','10','10')),
				$object->th('f(x)').$object->td($object->textfield('f0','','10','10')).$object->td($object->textfield('f1','','10','10')).$object->td($object->textfield('f2','','10','10')).$object->td($object->textfield('f3','','10','10')),		       
				]
			       ));
    print $object->p;
    $name = $object->param('name'),
    $x0 = $object->param('x0'),
    $f0 = $object->param('f0'),
    $x1 = $object->param('x1'),
    $f1 = $object->param('f1'),
    $x2 = $object->param('x2'),
    $f2 = $object->param('f2'),
    $x3 = $object->param('x3'),
    $f3 = $object->param('f3'),

    print $object->submit(-name=>'GO1', -value=>'Approximate f(x)'),                   #submit button
    $object->p;
    print $object->defaults('Clear table','Clear table'),                 #defaults button
    $object->p;
    print $object->body(`date`);                                          #print date and time on page
    print $object->end_form();                                            #end the current form 
    print $object->hr;                                                    #print a horisontal line
    
}

sub print_to_file
{
    $server =  $ENV{'SERVER_NAME'};
    $agent =  $ENV{'HTTP_USER_AGENT'}; 
    $ip = $ENV{'REMOTE_ADDR'}; 
    open(LOGFILE,">>inputs.log") || die("Error1: Cannot open file");
    print LOGFILE " ",`date`;                                                   #print date and time on log file
    print LOGFILE " User Data: Name: $name, IP: $ip, Browser: $agent ","\n";
    print LOGFILE "\n\n";  #print data to log file
    close(LOGFILE);
}

sub print_data
{
    open(DATAOUT,">dataout.dat")||die("Error2: Cannot open file");
    print DATAOUT "$x0 $f0", "\n";
    print DATAOUT "$x1 $f1", "\n"; 
    print DATAOUT "$x2 $f2", "\n";
    print DATAOUT "$x3 $f3", "\n";
    close(DATAOUT);
}

sub Lagrange
{
    open(DATAOUT0,">dataout1.dat")||die;
    close(DATAOUT0);
    open(DATAOUT1,">>dataout1.dat")||die("Error3: Cannot open file");
    $dx = ($x3-$x0)/100;
    $x = $x0-$dx;
    for ($i=1;$i<=101;$i++)
    {
	$x = $x + $dx;
	$f =  ($x-$x1)*($x-$x2)*($x-$x3)/(($x0-$x1)*($x0-$x2)*($x0-$x3))*$f0 + ($x-$x0)*($x-$x2)*($x-$x3)/(($x1-$x0)*($x1-$x2)*($x1-$x3))*$f1 + ($x-$x0)*($x-$x1)*($x-$x3)/(($x2-$x0)*($x2-$x1)*($x2-$x3))*$f2 + ($x-$x0)*($x-$x1)*($x-$x2)/(($x3-$x0)*($x3-$x1)*($x3-$x2))*$f3; 
	print DATAOUT1 "$x $f","\n";
    }
    close(DATAOUT1);
}

sub return_form
{
    print $object->start_form();
    print $object->body('Your name is:', $object->b("<font color=blue>",$name)),
    $object->p,
    "<font color=black>";
#    print $object->body('You gave point: ', $object->b("<font color=blue>",$x0)),
#    $object->p,
#    "<font color=black>";
    print $object->body('Here is the plot:'),
    $object->p;
    print $object->img({src=>"http://www.astro.auth.gr/~simos/images/ArithmAnal/Lagrange/Lagrange.jpg"}),
    $object->p,
    $object->body('The red stars (', $object->b("<font color=red>",'*'),' <font color=black>) are the positions of the given points.'),
    $object->br,
    $object->body('The',$object->b("<font color=blue>",'blue'), "<font color=black>", 'curve is the', $object->b('3rd order Lagrange polynomial approximation')),
    $object->br,
    $object->body('The',$object->b("<font color=green>",'green'), "<font color=black>",' curve is the', $object->b('Cubic Spline approximation'));
}


sub Gnuplot
{
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit "3rd order Lagrange polynomial and Cubic Spline approximation of the provided data points" #the title of the plot
	unset key
	set grid
	set o "Lagrange.ps"                                                         #the name of the plot
	set terminal pos color
	set ylabel "f(x)"
	set xlabel "x"
	plot "dataout.dat" u 1:2 w p pt 3 ps 2 lt 1, "dataout1.dat" u 1:2 w l lt 3, "dataout.dat" u 1:2 smooth csplines w l lt 2
gnuplot_Commands_done
	close(GNUPLOT);
}

#counts the visits and prints to the webpage
sub webtail
{
    print $object->p,
    $object->hr;
    $countfile = "cgicount";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
    print $object->hr;  
    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:simos@astro.auth.gr'},'simos@astro.auth.gr');
    print $object->p;
    print $object->body("<!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=895257;var sc_invisible=0;var sc_partition=7;var sc_security='15768a57';</script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img  src='http://c8.statcounter.com/counter.php?sc_project=895257&amp;java=0&amp;security=15768a57&amp;invisible=0' alt='simple hit counter' border='0'></a> </noscript>
<!-- End of StatCounter Code -->");
}
