#!/usr/bin/perl 
use Math::Trig;
use CGI qw(:standard);                          #call CGI.pm

$pi = acos(-1);
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                           #create a new CGI object
print_header();                              #call subroutine "print_header"
print_form();                                #call subroutine "form"
if (param())
{
    print_to_file();                             #print data to log file "inputs.log" to have an input reference
    print_function();                            #print finction to file for reading by NR.pl
    nr();                                        #call subroutine nr
    &Gnuplot();                                  #call subroutine Gnuplot
    return_form();                               #call subroutine return_form
    print $object->end_html();                   #end the html

###### The following are the required subroutines ######
}
sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Newton-Raphson',                                   #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Newton-Raphson'),                                                 #level 1 header
    $object->startform('POST');
}


sub print_form
{
    print $object->start_form('POST'),
    $object->body('    :'),
    $object->textfield('name','guest','50','50'),                          #create a text field
    $object->p,
    $object->body('    f(x) ='),
    $object->textfield('function',                                         #create a text field
		       'sin(x)','100','100'),
    $object->body('*Please use x as the parameter and leave a space before and after x. If you want to use power you can write x followed by ** and the exponential, for example x**2 is x squared. log(x) is the natural logarithm of x.'),
    $object->p;                                                            #paragraph
    $name = $object->param('name');                                        #get input and put it in "name"
    $function = $object->param('function');                                #get input and put it in "function"
    
    print $object->body('           :  '),
    $object->textfield('space','[0:2*pi]'),                                #create a textfield
    $object->p;
    $space = $object->param('space');                                      #get input and put it in "space"
    
    print $object->body('    : '),
    $object->textfield('point','0'),
    $object->p;
    $point = $object->param('point');
    
    print $object->body('       : ');
    print $object->popup_menu('methods',['Newton-Raphson'],'Newton-Raphson'),
                                                                          #create pop-up menu
    $object->p;
    $method = $object->param('methods');
    
    print $object->submit(-name=>'GO1', -value=>''),                     #submit button
    $object->p;
    print $object->reset('Reset to default values','Reset to default values'),#reset button
	$object->p;
    print $object->body(`date`);                                          #print date and time on page
    print $object->end_form();                                            #end the current form 
    print $object->hr;                                                    #print a horisontal line
}


sub print_to_file
{
    open(LOGFILE,">>inputs.log") || die("Error1: Cannot open file");
    print LOGFILE " ",`date`;                                                   #print date and time on log file
    print LOGFILE " User: $name, Function: $function, Space:  $space ","\n\n";  #print data on log file
    close(LOGFILE);
}

sub print_function
{
    open (OUTFUNCTION,">function.in") || die("Error2: Cannot open file"); 
    print OUTFUNCTION "$function", "\n";
    print OUTFUNCTION $point;
    close(OUTFUNCTION);
}

sub nr
{
    system("./NR.pl");
    open(ERROR,"error.dat")||die;
    read(ERROR,$check,10);
    close(ERROR);
    if ($check==1)
    {
	print $object->body("More than 10 steps needed to approach the root"),
	$object->p,
	$object->body("Please try again using another starting point");
	die;
    } 
     
}

sub return_form
{
    open (PLOT,"data2.plot") || die;
    @data = <PLOT>;
    $steps = @data;
    close(PLOT);
    $xi = @data[$steps-1];


    print $object->start_form();
        
    print $object->body(' : ', $function),
    $object->p,
    $object->body(' :', $space),
    $object->p,
    $object->body('  :', $method),
    $object->p,
    $object->body('  :', $point),
    $object->p,
    $object->body('  :',$xi),
    $object->p,
    $object->body('   :',$steps),
    $object->p,
    $object->body('  :'),
    $object->p;
    print $object->img({src=>"function.gif"});
    
    print $object->end_form();
    for ($nn=0;$nn<$steps;$nn++)
    {
	print $object->body(' ', $nn+1, ':', 'x =', @data[$nn]),
	$object->p;
    }
}


sub Gnuplot
{
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit "$name 's plot"                                                          #the title of the plot
	unset key
	set grid
	set o "function.gif"                                                         #the name of the plot
	set terminal gif
	plot $space $function, 0 lt 3,"data.plot" u 2:3 pt 2 ps 2 lt -1, "data1.plot" every 2 u 1:2 w p pt 1 ps 3 lt -1,"data1.plot" u 1:2:3:4 w vectors lt -1   
gnuplot_Commands_done
	close(GNUPLOT);
}
