#!/usr/bin/perl
use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"
if (param('GO1'))
  {
    print_to_logfile();
    print_to_file();                             #print data to log file "inputsR.log" to have an input reference
    Trapezium_Romberg();
    $Int1 = $Int;
    $ERROR1 = $ERROR;
    &Gnuplot();
    return_form();                               #call subroutine return_form

#    print $object->start_form(),
#    $object->body('If you want to apply Romberg',"'",'s correction, please give k = '),
#      $object->textfield('R','0.5','20','20');
#    $R = $object->param('R');
#    print $object->p,
#      $object->submit(-name=>'GO2', -value=>'Proceed with Rombergs correction');
#    $check = $R;
#    print $object->p,
#      $object->reset('Reset to default values','Reset to default values'),
#	$object->hr;
#    if(param('GO2')
#       {
#	 print $object->start_form();
#	 $steps = $steps/$R;
#	 Trapezium_Romberg();
#	 $Int2 = $Int;
#	 $Int = ($R*$R*$Int1 - $Int2)/($R*$R-1);
#	 print $object->br,
#	   $object->body('The integral after Romberg',"'",'s correction with k = ', $R, 'is:', $object->b(" <font color=blue>",' I = ', $Int));
#       }
#  }

    #    webtail();
    print $object->end_html();                   #end the html
  }

sub print_header
  {
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Trapezium',                                          #start the html
			       'kokkotas@astro.auth.gr'),
				 $object->h1('Calculate Integrals with the Trapezium',' method '),               #level 1 header
				   $object->startform('POST');
  }

sub print_form
{
  print $object->start_form('POST'),
    $object->body('(This is the Integrator of the course Numerical Analysis. The user provides a function f(x) and the limits of the integral. After pressing the "Calculate it" button, the program plots f(x) and calculates the integral using either one of the chosen methods or all of them so that comparisons can be made.', $object->b("<font color=blue>", 'All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). In function f(x), it is suggested to put a space before and after each x.', $object->b(" <font color=black>", ' For questions or to report problems please contact: simos@astro.auth.gr )'))),
      $object->p,
	$object->body('*Please give your name: '),
	  $object->textfield('name','guest','20','20'),                                #create a text field
	    $object->p,
	      $object->body('Please give a function f(x) = '),
		$object->textfield('function','sin(x)','30','40'), 
		  $object->p,
		    $object->body('Please give x minimum x<sub>min </sub> = '),
		      $object->textfield('x_min','0','20','20'),
			$object->br,
			  $object->body('Please give x maximum x<sub>max </sub>= '),
			    $object->textfield('x_max','10','20','20'),
			      $object->br,
				$object->body('Please give number of steps n = '),
				  $object->textfield('steps','100','20','20'),
				    $object->p,
				      $object->body('Please choose one of the integration methods: '),
					$object->popup_menu('methods',['Trapezium','Simpson','Gauss', 'All Methods'],'All Methods'),
					  $object->br,
					    $object->body('If you choose "All Methods", you will be able to compare the above integration methods');
  $object->p;
  $method = $object->param('methods');
  $name = $object->param('name');
  $function = $object->param('function');
  $funct = $function;
  $y = '$x';
  $funct =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($y)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
  $funct =~ s/\*x/*($y)/gi;                          #replace *x with *($x)
  $funct =~ s/x\*/($y)*/gi;                          #replace x* with ($x)*
  $funct =~ s/\sx/($y)/gi;                           #replace  x with ($x)
  $funct =~ s/x\s/($y)/gi;                           #replace x  with ($x)
  $funct =~ s/\+x / +($y)/gi;                        #replace +x with +($x)
  $funct =~ s/x\+/($y)+/gi;                          #replace x+ with ($x)+
  $funct =~ s/\-x/-($y)/gi;                          #replace -x with -($x)
  $funct =~ s/x\-/($y)-/gi;                          #replace x- with ($x)

  $x_min = $object->param('x_min');
  $x_max = $object->param('x_max');
  $steps = $object->param('steps');

  print $object->p;
  print $object->submit(-name=>'GO1', -value=>'GO1'),                   #submit button
    $object->p;
  print $object->reset('Reset to default values','Reset to default values'),                 #defaults button
    $object->p;
  print $object->defaults('Erase everything','Erase everything'),                 #defaults button
    $object->p;
  print $object->body(`date`);                                          #print date and time on page
  print $object->end_form();                                            #end the current form 
  print $object->hr;                                                    #print a horisontal line

}

sub print_to_file
  {
    open(DATA,">dataR.dat") || die("Error");
    close(DATA);
    open(DATA1,">>dataR.dat") || die("Error");
    $dx = abs($x_max-$x_min)/$steps;
    $h = abs($x_max-$x_min)/5;
    $x = $x_min - $dx;
    for ($i=1;$i<=$steps+1;$i++)
    {
	$x = $x + $dx;
	$f = eval $funct;
	print DATA1 "$x $f", "\n";
    }
    close(DATA1);
}

sub print_to_logfile
  {
    $server =  $ENV{'SERVER_NAME'};
    $agent =  $ENV{'HTTP_USER_AGENT'}; 
    $ip = $ENV{'REMOTE_ADDR'};  
    open(DATA2,">>inputsR.log") || die;
    print DATA2 " ",`date`;
    print DATA2 " User Data: Name: $name, IP: $ip, Browser: $agent ","\n";
    print DATA2 " User Request: Function: $function, x_min: $x_min, x_max: $x_max ","\n";
    print DATA2 "\n";
    close(DATA2);
  }

sub Trapezium_Romberg
  {
    $Int = 0;
    $dx = abs($x_max-$x_min)/$steps;
    $x = $x_min;
    for ($k=0;$k<=$steps-1;$k++)
      {
	$kk=$k+1;
	#	$k = $kk;	
	#	print $object->body($k," ");
	#$x = $x + $dx;
	$f0 = eval $funct;
	$x = $x + $dx;
	$f1 = eval $funct;
	#	$x = $x + $dx;
	#	print $object->body($x);
	#	print $object->br;
	#	$f2 = eval $funct;
	#$x = $x - $dx;
	$Int = $Int + $dx/2.0*($f0 + $f1);
	
      }
    $ERROR = - ($x_max-$x_min)/12*$dx*$dx;
  }

sub return_form
  {
    print $object->start_form();
    print $object->body('Your name is:', $object->b("<font color=blue>",$name)),
      $object->p,
	"<font color=black>";
    #    print $object->body('You gave function: ', $object->b("<font color=blue>",$function)),
    #    $object->p,
    "<font color=black>";
    print $object->body('You have asked to calculate the integral of <font color=blue> f(x) = ', $object->b($function),' <font color=black> in the interval:', $object->b("<font color=blue>",'[',$x_min,',',$x_max,']')),
      $object->p,
	"<font color=black>";
    print $object->body('Here is the plot:'),
      $object->p;
    print $object->img({src=>"Simpson1.gif"}),
      $object->p,
	$object->body('The Integral of <font color=blue> f(x) <font color =black> from <font color=blue>', $x_min,' <font color=black> to <font color=blue> ',$x_max,' <font color=black> is:', $object->b("<font color=blue>",'I =', $Int1)),
	  "<font color=black>",
	    $object->br,
	      $object->body('The approximate error of the method is <font color=blue> E ~ ',$object->b($ERROR1)),
		"<font color=black>";

    #        print $object->start_form(),
    print $object->p,
      $object->body('If you want to apply Romberg',"'",'s correction, please give k = '),
	$object->textfield('R','0.5','20','20');
    $R = $object->param('R');
    print $object->p,
      $object->submit(-name=>'GO2', -value=>'Proceed with Rombergs correction');
    $check = $R;
    print $object->p,
      $object->reset('Reset to default values','Reset to default values'),
	$object->hr;
    print $object->end_form();
    if(param('GO2'))
      {
	print $object->start_form();
	#$steps = $steps/$R;
	Trapezium_Romberg();
	$Int2 = $Int;
	#$Int = ($R*$R*$Int1 - $Int2)/($R*$R-1);
	print $object->br,
	  $object->body('The integral after Romberg',"'",'s correction with k = ', $R, 'is:', $object->b(" <font color=blue>",' I = ', $Int));
	print $object-> end_form();
      }
  }

   sub Gnuplot
   {
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit " The integral is equal to the marked area under the plot "               #the title of the plot
	unset key
	set grid
	set o "Simpson1.gif"                                                           #the name of the plot
	set terminal gif
	set ylabel "f(x)"
	set xlabel "x"
	plot [$x_min-$h:$x_max+$h] "dataR.dat" u 1:2 w filledcurves y1=0 lt -1, $function w l lt 1, 0 w l lt -1
gnuplot_Commands_done
    close(GNUPLOT);
  }
















#counts the visits and prints to the webpage
sub webtail
{
    print $object->p,
    $object->hr;
    $countfile = "cgicountR";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
    print $object->hr;  
    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:simos@astro.auth.gr'},'simos@astro.auth.gr');
    print $object->p;
    print $object->body("<!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=895250;var sc_invisible=0;var sc_partition=7;var sc_security='ccb97b32';</script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img  src='http://c8.statcounter.com/counter.php?sc_project=895250&amp;java=0&amp;security=ccb97b32&amp;invisible=0' alt='web stats' border='0'></a> </noscript>
<!-- End of StatCounter Code -->");
}
