#!/usr/bin/perl 
use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"
if (param())
{
    print_to_file();
    rk4();
    rk6();
    adams();
    &Gnuplot();
    return_form();                               #call subroutine return_form
    webtail();
    print $object->end_html();                   #end the html
}
sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Adams',                                   #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Adams vs Runge-Kutta 4th order'),                                                 #level 1 header
    $object->startform('POST');
}

#Creates the form
sub print_form
{
    print $object->start_form('POST'),
    $object->body('( This is the Adams method for solving ODEs. It is recommented that you first run the program using the default values in order to see a working example. Fields marked with a star are optional. After pressing GO!, scroll down to see the results. Hit Refresh, if the output does not change after changes in the input.', $object->b("<font color=blue>", 'All trigonometric functions are supported. Powers must be entered using **, for example x^2 must be entered as x**2. The natural logarithm o x must be entered as log(x). In function f(x), it is suggested to put a space before and after each x. ', $object->b(" <font color=black>", ' For questions or to report problems please contact: simos@astro.auth.gr )'))),
    $object->p,
    $object->body('*Please give your name: '),
    $object->textfield('name','guest','20','20'),                          #create a text field
    $object->p,
    $object->body('Please give the Right Hand Side of the Ordinary Differential Equation (ODE): y',"'",' = '),
    $object->textfield('RHS','','30','30'),
    $object->p,
    $object->body('Please give initial conditions that satisfy the ODE:'),
    $object->br,
    $object->body('x<sub>0</sub> = '),$object->textfield('x_0','0','20','20'),
    $object->body(', y<sub>0</sub> = '),$object->textfield('y_0','0','20','20'),
    $object->p,
    $object->body('Please give an ending value for the plot: x<sub>end</sub> = '),
    $object->textfield('x_max','1','20','20'),
    $object->p;
    $name = $object->param('name');
    $RHS = $object->param('RHS');
    $x_0 = $object->param('x_0');
    $y_0 = $object->param('y_0');
    $x_max = $object->param('x_max');

    $funct = $RHS;
    $z = '$x';
    $w = '$y';
    $funct =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($z)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $funct =~ s/\*x/*($z)/gi;                          #replace *x with *($x)
    $funct =~ s/x\*/($z)*/gi;                          #replace x* with ($x)*
    $funct =~ s/\sx/($z)/gi;                           #replace  x with ($x)
    $funct =~ s/x\s/($z)/gi;                           #replace x  with ($x)
    $funct =~ s/\+x / +($z)/gi;                        #replace +x with +($x)
    $funct =~ s/x\+/($z)+/gi;                          #replace x+ with ($x)+
    $funct =~ s/\-x/-($z)/gi;                          #replace -x with -($x)
    $funct =~ s/x\-/($z)-/gi;                          #replace x- with ($x)

    $funct =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($w)/gi;   #replace y that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $funct =~ s/\*y/*($w)/gi;                          #replace *y with *($x)
    $funct =~ s/y\*/($w)*/gi;                          #replace y* with ($x)*
    $funct =~ s/\sy/($w)/gi;                           #replace  y with ($x)
    $funct =~ s/y\s/($w)/gi;                           #replace y  with ($x)
    $funct =~ s/\+y / +($w)/gi;                        #replace +y with +($x)
    $funct =~ s/y\+/($w)+/gi;                          #replace y+ with ($x)+
    $funct =~ s/\-y/-($w)/gi;                          #replace -y with -($x)
    $funct =~ s/y\-/($w)-/gi;                          #replace y- with ($x)

    print $object->submit(-name=>'GO1', -value=>'Solve'),                   #submit button
    $object->p;
    print $object->reset('Reset to default values','Reset to default values'),#defaults button
      $object->p,
	$object->defaults('Erase everything','Erase everything'),#defaults button
	  $object->p;
    print $object->body(`date`);                                          #print date and time on page
    print $object->end_form();                                            #end the current form 
    print $object->hr;                                                    #print a horisontal line
}

sub print_to_file
{
    $server =  $ENV{'SERVER_NAME'};
    $agent =  $ENV{'HTTP_USER_AGENT'}; 
    $ip = $ENV{'REMOTE_ADDR'}; 
    open(LOGFILE,">>inputs.log") || die("Error1: Cannot open file");
    print LOGFILE " ",`date`;                                                   #print date and time on log file
    print LOGFILE " User Data: Name: $name, IP: $ip, Browser: $agent ","\n";
    print LOGFILE " User Request: y'=$RHS, x_0 = $x_0, y_0 = $y_0 ","\n\n";  #print data to log file
    close(LOGFILE);
    open(LOGFILE1,">inputs1.log") || die("Error2: Cannot open file");
    print LOGFILE1 "$x_0 $y_0","\n";
    close(LOGFILE1);
}

sub rk4()
{
    open(DATAOUT2,">data2.dat")||die;
    close(DATAOUT2);
    open(DATAOUT3,">>data2.dat")||die("Error3: Cannot open file");
    
    $h = ($x_max-$x_0)/100.0;
    $x = $x_0;
    $y = $y_0;
    $f = $y;
    print DATAOUT3 "$x $f","\n";

    for ($i=1;$i<=100;$i++)
    {
	$k1 = eval "$funct";
	$k1 = $h*$k1;
	$x = $x + 0.5*$h; 
	$y = $y + 0.5*$k1;
	$k2 = eval "$funct";
	$k2 = $h*$k2;
	$y = $y - 0.5*$k1 + 0.5*$k2;
	$k3 = eval "$funct";
	$k3 = $h*$k3;
	$x = $x + 0.5*$h;
	$y = $y - 0.5*$k2 + $k3;
	$k4 = eval "$funct";
	$k4 = $h*$k4;
 
	$f = $f + 1.0/6.0*($k1 + 2.0*$k2 + 2.0*$k3 + $k4);
	$y = $f;
	print DATAOUT3 "$x $f","\n";
    }
    close(DATAOUT3);
}

sub rk6()
{
  @fff = ();
  @yyy = ();
  open(DATAOUT4,">data3.dat")||die;
  close(DATAOUT4);
  open(DATAOUT5,">>data3.dat")||die("Error3: Cannot open file");
  
  $h = ($x_max-$x_0)/100.0;
  $x = $x_0;
  $y = $y_0;
  $f = $y;
  print DATAOUT5 "$x $f","\n";
  $xx = $x;
  $yy = $y;
  $fff[1] = eval "$funct";
  
  for ($i=1;$i<=3;$i++)
    {
      $xx = $x;
      $yy = $y;
      $k1 = eval "$funct";
      $k1 = $h*$k1;
      
      $x = $xx + 1.0/4.0*$h; 
      $y = $yy + 1.0/4.0*$k1;
      $k2 = eval "$funct";
      $k2 = $h*$k2;
      
      $x = $xx + 3.0/8.0*$h;
      $y = $yy + 3.0/32.0*$h + 9.0/32.0*$k2;
      $k3 = eval "$funct";
      $k3 = $h*$k3;
      
      $x = $xx + 12.0/13.0*$h;
      $y = $yy + 1932.0/2197*$k1 - 7200.0/2197.0*$k2 + 7296.0/2197.0*$k3;
      $k4 = eval "$funct";
      $k4 = $h*$k4;
      
      $x = $xx + $h;
      $y = $yy + 439.0/216.0*$k1 - 8.0*$k2 + 3680.0/513.0*$k3 - 845.0/4104.0*$k4;
      $k5 = eval "$funct";
      $k5 = $h*$k5;
      
      $x = $xx + 1.0/2.0*$h;
      $y = $yy - 8.0/27.0*$k1 + 2*$k2 - 3544.0/2565.0*$k3 + 1859.0/4104.0*$k4 -11.0/40.0*$k5; 
      $k6 = eval "$funct";
      $k6 = $h*$k6;
      
      $x = $xx + $h;	
      
      #	$f = $f + 25.0/216*$k1 + 1408.0/2565.0*$k3 + 2197.0/4104.0*$k4 - 1.0/5.0*$k5;
      $f = $f + 16.0/135.0*$k1 + 6656.0/12825.0*$k3 + 28561.0/56430.0*$k4 - 9.0/50.0*$k5 + 2.0/55.0*$k6;
      $y = $f;
      $yyy[i] = $y;
      $fff[i+1] = eval "$funct";
      print DATAOUT5 "$x $f","\n";
    }
  close(DATAOUT5);
}

sub adams
  {
    #    open(DATAOUT4,">data3.dat")||die;
    #    close(DATAOUT4);
    open(DATAOUT5,">>data3.dat")||die("Error3: Cannot open file");

    for($i=5;$i<=100;$i++)
      {

	$yyy[i] = $yyy[i-1] + 1.0/24.0*$h* ( 55.0* $fff[i-1]  - 59.0*$fff[i-2] + 37.0*$fff[i-3] -9.0*$fff[i-4]);
	$y = $yyy[i];
	$x = $x + $h;
	$fff[i] = eval "$funct";
	
	print DATAOUT5 "$x $y","\n";
      }
    close(DATAOUT5);
  }
sub return_form
{
    print $object->body('You gave ODE: y',"'",' =', $RHS),
    $object->p;
    print $object->img({src=>"solution1.gif"}),
    $object->p,
    $object->body('The big', $object->b('black'),'star (*) represents the provided initial data'),
    $object->br,
    $object->body('The',$object->b("<font color=blue>",'blue'),"<font color=black>", 'xes (', "<font color=blue>",'x',"<font color=black>",') represents the solution given by the 4th order Runge-Kutta method'),
    $object->br,
    $object->body('The',$object->b("<font color=red>",'red'),"<font color=black>", 'line (', "<font color=red>",'-',"<font color=black>",') represents the solution given by Adams',"'",' method');

}

sub Gnuplot
{
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit "solution of y' = $RHS"                                                  #the title of the plot
	unset key
	set grid
	set o "solution1.gif"                                                         #the name of the plot
	set terminal gif
	set ylabel "y"
	set xlabel "x"
	plot "inputs1.log" u 1:2 w p ps 3 pt 3 lt -1, "data2.dat" u 1:2 w p pt 2 lt 3, "data3.dat" u 1:2 w l pt 3 lt 1
gnuplot_Commands_done
	close(GNUPLOT);
}

#counts the visits and prints to the webpage
sub webtail
{
    print $object->hr;
    $countfile = "cgicount";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    print $object->a({href=>"http://www.astro.auth.gr/~simos/cgi-bin/link.pl"}, 'Back to the Interactive Numerical Analysis page'); 
    print $object->hr;  
    print $object->p;
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:simos@astro.auth.gr'},'simos@astro.auth.gr');
    print $object->p;
    print $object->body("<!-- Start of StatCounter Code --><script type='text/javascript' language='javascript'>var sc_project=895244;var sc_invisible=0;var sc_partition=7;var sc_security='8c871003';</script><script type='text/javascript' language='javascript' src='http://www.statcounter.com/counter/counter.js'></script><noscript><a href='http://www.statcounter.com/' target='_blank'><img  src='http://c8.statcounter.com/counter.php?sc_project=895244&amp;java=0&amp;security=8c871003&amp;invisible=0' alt='counter easy hit' border='0'></a> </noscript>
<!-- End of StatCounter Code -->");
}
