#!/usr/bin/perl 
use Math::Trig;
use CGI qw(:standard);                      #call CGI.pm

$pi = acos(-1);                             #pi
$date = date;
$gnuplot = "gnuplot";
$object = new CGI;                          #create a new CGI object
print_header();                             #call subroutine "print_header"
print_form();                               #call subroutine "form"

rk2();
rk4();
rk6();
#&Gnuplot();
return_form();                               #call subroutine return_form
webtail();
print $object->end_html();                   #end the html

sub print_header
{
    print $object ->header('text/html');                                           #create an http header
    print  $object->start_html('Runge-Kutta',                                   #start the html
			       'kokkotas@astro.auth.gr'),
    $object->h1('Runge-Kutta'),                                                 #level 1 header
    $object->startform('POST');
}

#Creates the form
sub print_form
{
    print $object->start_form('POST'),
    $object->body('(It is recommented that you first run the program using the default values in order to see a working example. Fields marked with a star are optional. After pressing GO!, scroll down to see the results. Hit Refresh, if the output does not change after changes in the input)'),
    $object->p,
    $object->body('*Please give your name: '),
    $object->textfield('name','guest','20','20'),                          #create a text field
    $object->p,
    $object->body('Please give the Right Hand Side of the Ordinary Differential Equation (ODE): y',"'",' = '),
    $object->textfield('RHS','','30','30'),
    $object->p,
    $object->body('Please give initial conditions that satisfy the ODE:'),
    $object->br,
    $object->body('x<sub>0</sub> = '),$object->textfield('x_0','0','20','20'),
    $object->body(', y<sub>0</sub> = '),$object->textfield('y_0','0','20','20'),
    $object->p,
    $object->body('Please give an ending value for the plot: x<sub>max</sub> = '),
    $object->textfield('x_max','1','20','20'),
    $object->p;
    $name = $object->param('name');
    $RHS = $object->param('RHS');
    $x_0 = $object->param('x_0');
    $y_0 = $object->param('y_0');
    $x_max = $object->param('x_max');

    $funct = $RHS;
    $z = '$x';
    $w = '$y';
    $funct =~ s/[^a-z \+\*\-]x[^a-z \*\+\-]/($z)/gi;   #replace x that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $funct =~ s/\*x/*($z)/gi;                          #replace *x with *($x)
    $funct =~ s/x\*/($z)*/gi;                          #replace x* with ($x)*
    $funct =~ s/\sx/($z)/gi;                           #replace  x with ($x)
    $funct =~ s/x\s/($z)/gi;                           #replace x  with ($x)
    $funct =~ s/\+x / +($z)/gi;                        #replace +x with +($x)
    $funct =~ s/x\+/($z)+/gi;                          #replace x+ with ($x)+
    $funct =~ s/\-x/-($z)/gi;                          #replace -x with -($x)
    $funct =~ s/x\-/($z)-/gi;                          #replace x- with ($x)

    $funct =~ s/[^a-z \+\*\-]y[^a-z \*\+\-]/($w)/gi;   #replace y that is not surrounded by a-z+ -* by ($x)ie replace (x) by ($x)
    $funct =~ s/\*y/*($w)/gi;                          #replace *y with *($x)
    $funct =~ s/y\*/($w)*/gi;                          #replace y* with ($x)*
    $funct =~ s/\sy/($w)/gi;                           #replace  y with ($x)
    $funct =~ s/y\s/($w)/gi;                           #replace y  with ($x)
    $funct =~ s/\+y / +($w)/gi;                        #replace +y with +($x)
    $funct =~ s/y\+/($w)+/gi;                          #replace y+ with ($x)+
    $funct =~ s/\-y/-($w)/gi;                          #replace -y with -($x)
    $funct =~ s/y\-/($w)-/gi;                          #replace y- with ($x)

    print $object->submit(-name=>'GO1', -value=>'GO!'),                   #submit button
    $object->p;
    print $object->defaults('Reset to default values','Reset to default values'),#defaults button
	$object->p;
    print $object->body(`date`);                                          #print date and time on page
    print $object->end_form();                                            #end the current form 
    print $object->hr;                                                    #print a horisontal line
}

sub rk2()
{
    open(DATAOUT0,">data1.dat")||die;
    close(DATAOUT0);
    open(DATAOUT1,">>data1.dat")||die("Error3: Cannot open file");
    
    $h = ($x_max-$x_0)/100.0;
    $x = $x_0;
    $y = $y_0;
    $f = $y;
    print DATAOUT1 "$x $f","\n";

    for ($i=1;$i<=101;$i++)
    {
	$k1 = eval "$funct";
	$k1 = $h*$k1;
	$x = $x + $h; 
	$y = $y + $k1;
	$k2 = eval "$funct";
	$k2 = $h*$k2;
	$f = $f + 0.5*($k1+$k2);
	print DATAOUT1 "$x $f","\n";
    }
    close(DATAOUT1);
}


sub rk4()
{
    open(DATAOUT2,">data2.dat")||die;
    close(DATAOUT2);
    open(DATAOUT3,">>data2.dat")||die("Error3: Cannot open file");
    
    $h = ($x_max-$x_0)/100.0;
    $x = $x_0;
    $y = $y_0;
    $f = $y;
    print DATAOUT3 "$x $f","\n";

    for ($i=1;$i<=101;$i++)
    {
	$k1 = eval "$funct";
	$k1 = $h*$k1;
	$x = $x + 0.5*$h; 
	$y = $y + 0.5*$k1;
	$k2 = eval "$funct";
	$k2 = $h*$k2;
	$y = $y - 0.5*$k1 + 0.5*$k2;
	$k3 = eval "$funct";
	$k3 = $h*$k3;
	$x = $x + 0.5*$h;
	$y = $y - 0.5*$k2 + $k3;
	$k4 = eval "$funct";
	$k4 = $h*$k4;
 
	$f = $f + 1.0/6.0*($k1 + 2.0*$k2 + 2.0*$k3 + $k4);
	$y = $f;
	print DATAOUT3 "$x $f","\n";
    }
    close(DATAOUT3);
}


sub rk6()
{
    open(DATAOUT4,">data3.dat")||die;
    close(DATAOUT4);
    open(DATAOUT5,">>data3.dat")||die("Error3: Cannot open file");
    
    $h = ($x_max-$x_0)/100.0;
    $x = $x_0;
    $y = $y_0;
    $f = $y;
    print DATAOUT5 "$x $f","\n";

    for ($i=1;$i<=101;$i++)
    {
	$xx = $x;
	$yy = $y;
	$k1 = eval "$funct";
	$k1 = $h*$k1;

	$x = $xx + 1.0/4.0*$h; 
	$y = $yy + 1.0/4.0*$k1;
	$k2 = eval "$funct";
	$k2 = $h*$k2;

	$x = $xx + 3.0/8.0*$h;
	$y = $yy + 3.0/32.0*$h + 9.0/32.0*$k2;
	$k3 = eval "$funct";
	$k3 = $h*$k3;

	$x = $xx + 12.0/13.0*$h;
	$y = $yy + 1932.0/2197*$k1 - 7200.0/2197.0*$k2 + 7296.0/2197.0*$k3;
	$k4 = eval "$funct";
	$k4 = $h*$k4;

	$x = $xx + $h;
	$y = $yy + 439.0/216.0*$k1 - 8.0*$k2 + 3680.0/513.0*$k3 - 845.0/4104.0*$k4;
	$k5 = eval "$funct";
	$k5 = $h*$k5;

	$x = $xx + 1.0/2.0*$h;
	$y = $yy - 8.0/27.0*$k1 + 2*$k2 - 3544.0/2565.0*$k3 + 1859.0/4104.0*$k4 -11.0/40.0*$k5; 
	$k6 = eval "$funct";
	$k6 = $h*$k6;

	$x = $xx + $h;	
 
#	$f = $f + 25.0/216*$k1 + 1408.0/2565.0*$k3 + 2197.0/4104.0*$k4 - 1.0/5.0*$k5;
	$f = $f + 16.0/135.0*$k1 + 6656.0/12825.0*$k3 + 28561.0/56430.0*$k4 - 9.0/50.0*$k5 + 2.0/55.0*$k6;
	$y = $f;

	print DATAOUT5 "$x $f","\n";
    }
    close(DATAOUT5);
}


sub return_form
{
    print $object->body('You gave ODE: y',"'",' =', $RHS),
    $object->p;


}

sub Gnuplot
{
    open (GNUPLOT, "|$gnuplot");
    print GNUPLOT <<gnuplot_Commands_done;
    set tit "Solution of y' = $RHS"                                                          #the title of the plot
	unset key
	set grid
	set o "function.gif"                                                         #the name of the plot
	set terminal gif
	plot $space $function, 0 lt 3,"data.plot" u 2:3 pt 2 ps 2 lt -1, "data1.plot" every 2 u 1:2 w p pt 1 ps 3 lt -1,"data1.plot" u 1:2:3:4 w vectors lt -1   
gnuplot_Commands_done
	close(GNUPLOT);
}

#counts the visits and prints to the webpage
sub webtail
{
    print $object->hr;
    $countfile = "cgicount";
    $count = `cat $countfile`;
    chop($count);
    $count = $count + 1;
    open(INF,">$countfile");
    print INF "$count\n";
    close(INF);
    #print the counter and contact e-mail address
    print $object->body("<font color = black>", "<font size=1.5>",'This web page has been visited: ',"<font color=red>",$count,"<font color=black>",'times');
    print $object->br;
    print $object->body("<font color=black>","<font size=1.5>",'If you have any comments or questions please contact: ');
    print $object->a({href=>'mailto:contact@astro.auth.gr'},'simos@astro.auth.gr');
}
